package sorting;

public class PivotMedianOfThree implements PivotStrategy
{
    /**
     * Pick the median of the left, center, and right as the pivot.
     * Order these elements and move the pivot to the right. 
     * @return the pivot value.
     */
    public Integer choosePivot(Integer[] a, int left, int right, Stats stats) 
    {
        int center = (left + right)/2;
        
        // Order the left, center, and right elements.
        if (a[center].compareTo(a[left]) < 0) {
            Utilities.swapReferences(a, left, center);
            stats.moves += 2;
        }
        if (a[right].compareTo(a[left]) < 0) {
            Utilities.swapReferences(a, left, right);
            stats.moves += 2;
        }
        if (a[right].compareTo(a[center]) < 0) {
            Utilities.swapReferences(a, center, right);
            stats.moves += 2;
        }
        
        stats.compares += 3;

        // The pivot is the center element. 
        // Place it at position right.
        Utilities.swapReferences(a, center, right);
        stats.moves += 2;
        
        return a[right];
    }
}
