package sorting;

public class ShellSortSubOptimal implements SortingAlgorithm<Integer>
{
    /**
     * Simple insertion sort.
     * @param a an array of Comparable items.
     * @return sorting statistics.
     */
    @Override
    public Stats sort(Integer[] a) 
    {
        int j;
        long totalMoves = 0;
        long totalCompares = 0;
        
        for (int h = a.length/2; h >= 1; h /= 2) {            
            for (int pass = h; pass < a.length; pass++) {
                long moves = 0;
                long compares = 0;
                Integer tmp = a[pass];
                
                for (j = pass; j >= h && tmp.compareTo(a[j-h]) < 0; j -= h) {
                    a[j] = a[j-h];
                    moves++;
                    compares++;
                }
                
                if (j >= h) compares++;
                
                if (pass != j) {
                    a[j] = tmp;
                    moves++;
                }
                
                totalMoves += moves;
                totalCompares += compares;
            }
        }
        
        return new Stats(totalMoves, totalCompares);
    }

    @Override
    public Stats sort(MyLinkedList<Integer> list) { return null; };
}
